/*********************************************************
* function.h - function for measuring
*
* v_0.1
*
* Copyright (c)2014 Matej Z. All rights reserved.
* matej.zdenek@gmail.com
*********************************************************/

#ifndef __BRANCHFUSING_S
#define __BRANCHFUSING_S


typedef struct sStatItem
{
    double minimum;
    double maximum;
    double sum;
    double sumPow2;
    unsigned long long count;
} tStatItem;


//statistics
typedef struct sBranchFusingStat
{
    //computed from every signle sample
    tStatItem actualRAW;
    tStatItem totalRAW;

    //computed from output of IIR filter
    tStatItem actualIIR;
    tStatItem totalIIR;

	//computing of initial value of multiplicative constant
	int computingInitMultConst;
	int processedIntSamples;
	int totalInitSampesToCompute;
	double initMultConst;
	int discardPulses;
	float paramKonstantaNasobeni;

} tBranchFusingStat;

int BranchFusingPrintStatisticsMultConst(char* s, tBranchFusingStat *stats);
int BranchFusingPrintStatistics(char* s, int printHeader, tStatItem *statItem, char* text);
void BranchFusingClearStatistics(tBranchFusingStat *stats, int onlyActual, float paramKonstantaNasobeni);

int SlouceniVetviPredzesilovace(float* impuls1, int delka1, float* impuls2, int delka2, float* impulsSlouceny, char ZPRACOVAVANE_SOUBORY, float pomerZesileni);
int VypoctiPomerZesileniPredzesilovace(float* impuls1, int delka1, float* impuls2, int delka2, float* pomerZesileni, tBranchFusingStat *stats);


#endif
