/*********************************************************
* load.c - load files from measuring
*
* v_0.1
*
* Copyright (c)2014 Matej Z. All rights reserved.
* matej.zdenek@gmail.com
*********************************************************/

#include "loadSohaj.h"
#include "constants.h"
#include <stdio.h>

FILE* f1 = NULL;
FILE* f2 = NULL;


//vrati pocet nactenych vzorku, -1 pri chybe
int NactiVlnuNewADC(FILE* f, float* vlna)
{
	int number;
	int i = 0;
	char radek[200];

	while (fgets(radek, 150, f))
	{
		if (radek[0] == '\n')
		{
			return(i);
		}
		else if (radek[0] == '#')
		{
			//pravdpodobn je tu st s informac o  vpadku - provm
			if (radek[1] == 'b')
			{
				//toto je dek zanajc #begin
				//natu dal 3 dky - #end, mezera a zatek dalho pulzu
				fgets(radek, 150, f);
				fgets(radek, 150, f);
				fgets(radek, 150, f);

				//printf("\rPreskocena informace o vypadku pri prenosu dat.\r\n");
			}
			else
			{
				printf("!!! Chyba pi preskakovani vypadku\r\n");
				return(-1);
			}
		}
		else if (i < (MAX_IMPULSE_SIZE - 1))
		{
			number = 0;
			int d = 0;
			int go = 1;
			while (go == 1)
			{
				int digit = 0;
				switch (radek[d])
				{
					case '0':
						digit = 0;
						break;
					case '1':
						digit = 1;
						break;
					case '2':
						digit = 2;
						break;
					case '3':
						digit = 3;
						break;
					case '4':
						digit = 4;
						break;
					case '5':
						digit = 5;
						break;
					case '6':
						digit = 6;
						break;
					case '7':
						digit = 7;
						break;
					case '8':
						digit = 8;
						break;
					case '9':
						digit = 9;
						break;
					case 'A':
						digit = 10;
						break;
					case 'B':
						digit = 11;
						break;
					case 'C':
						digit = 12;
						break;
					case 'D':
						digit = 13;
						break;
					case 'E':
						digit = 14;
						break;
					case 'F':
						digit = 15;
						break;
					default:
						go = 0;
						break;

				}

				if (go == 1)
				{
					number = number * 16 + digit;
					d++;
				}
			}
			vlna[i++] = number;
		}
	}

	return(i);
}

int LoadDataSohaj(FILE *in, float *data_out, unsigned char *typ, int *delka, unsigned long long *cas_lost, unsigned long long *cas_begin, unsigned long long *cas_end, unsigned long long *lost_impulses)
{
	char radek[150];
	int a;

	for (a=0;a<MAX_IMPULSE_SIZE;a++){
		data_out[a] = 0;
	}

	while (fgets(radek, 150, in))
	{
		//kontrola znaku '#' na zatku
		if (radek[0] != '#')
		{
			printf("!!! Je ocekavan znak '#'\r\n");
			printf("radek obsahuje: %s\r\n", radek);
			return(0);
		}

		//there is a information about packet lost
		if (radek[1] == 'l')
		{
			//number of lost pulses
			sscanf(radek, "#lost_impulses %llu", lost_impulses);

			//begin time
			fgets(radek, 150, in);
			sscanf(radek, "#begin %llu", cas_begin);

			//end time
			fgets(radek, 150, in);
			sscanf(radek, "#end %llu", cas_end);

			*cas_lost = *cas_end - *cas_begin;

			//free line
			fgets(radek, 150, in);

			*typ = 2;
			return(1);
		}

		//there is a time information of pulse (#time_[ns])
		if (radek[1] == 't')
		{
			sscanf(radek, "#time_[ns] %llu", cas_begin);
		}

		//njak nesmysl za znakem #
		else
		{
			printf("!!! chyba: neocekavany znak za '#'. Aktualni radek: %150s\r\n", radek);
			return(0);
		}

		//naten vlny
		*delka = NactiVlnuNewADC(in, data_out);
		if (*delka < 0)
		{
			printf("Chyba nacitani dat impulsu.\r\n");
			return(0);
		}

		*typ = 1;
		return(1);

	}

	return(0);
}


int NactiHlavickuNewADC(FILE *f)
{
	int hlavicka = 1;
	int mezera = 0;
	char radek[200];
	
	//zkouska, zda je soubor prazdny
	fseek(f, 0L, SEEK_END); // seek to end of file
	if (ftell(f) == 0)
	{
		fprintf(stderr, "Soubor je prazdny.\n");
		return 1;
	}
	fseek(f, 0L, SEEK_SET);

	while (hlavicka)
	{
		fgets(radek,150,f);

		if (radek[0] == EOF)
			return (2);

		if (radek[0] == '\n'){
			mezera++;
		} else {
			mezera = 0;
		}
		if (radek[0] == '#'){
			mezera = 0;
			//mozne spracovani dat z hlavicky
		}

		if (mezera == 3) {
			hlavicka = 0;
			//printf("%s\r\n", hlaska);
		}
	}

	return 0;
}


int OpenSohajDatFile(char* SOUBOR1, char* SOUBOR2)
{
	//oteven nezeslenho souboru - HIGH
	f1 = fopen(SOUBOR1, "rb");
	if (f1 == NULL)
	{
		printf("Nemohu otevrit soubor HIGH - %s!\r\n", SOUBOR1);
		return 0;
	}
	printf("%s otevren.\r\n", SOUBOR1);


	//oteven souboru zeslenho - LOW
	f2 = fopen(SOUBOR2, "rb");
	if (f2 == NULL)
	{
		printf("Nemohu otevrit soubor LOW - %s!\r\n", SOUBOR2);
		return 0;
	}
	printf("%s otevren.\r\n", SOUBOR2);

	//preskoceni hlavicek v souborech
	if (NactiHlavickuNewADC(f1) != 0)
	{
		printf("Nepodarilo se preskocit hlavicky - file 1.\r\n");
		return 0;
	}
	if (NactiHlavickuNewADC(f2) != 0)
	{
		printf("Nepodarilo se preskocit hlavicky - file 2.\r\n");
		return 0;
	}

	return 1;
}


///Nacte obe vetve ADC prevodniku
///@CH1 - data vetve 1 (kanal 1)
///@CH2 - data vetve 2 (kanal 2)
///@delka - pocet vzorku pulzu
///@casImpulsu_ns - cas v ns kdy byl impulz ADC kartou zachycen
///@pulzKompletni - nechybi zadna cast pulzu (neni implementovano, nutno dodat do .dat souboru)
///@vypadek_ns - doba vypadku v ns pred pulzem
///@vypadek_pulzy - pocet zpracenych pulzu
int NactiPulzSohaj(float* CH1, float* CH2, int* delka, unsigned long long* casImpulsu_ns, int* pulzKompletni, unsigned long long* vypadek_ns, int* vypadek_pulzy)
{
	unsigned long long cas_lost1, cas_lost2, cas_begin1, cas_begin2, cas_end1, cas_end2, lost_impulses1, lost_impulses2;
	unsigned char typ1, typ2;
	int delka1, delka2;

	int read = 1;
	do
	{
		//nacten CH1 souboru
		if (!LoadDataSohaj(f1, CH1, &typ1, &delka1, &cas_lost1, &cas_begin1, &cas_end1, &lost_impulses1))
		{
			//end of file or error
			return 0;
		}
		//nacten CH2 souboru
		if (!LoadDataSohaj(f2, CH2, &typ2, &delka2, &cas_lost2, &cas_begin2, &cas_end2, &lost_impulses2))
		{
			//end of file or error
			return 0;
		}
		//preskoceni vypadku v souboru
		if (typ1 != 1)
			continue;
		else
			read = 0;

		//osetreni spatnych delek impulsu
		if (delka1 != delka2){
			printf("Neshoduji se delky nacitanych impulsu!\r\n");
			return 0;
		}
		*delka = delka1;

		*casImpulsu_ns = cas_begin1;
		*pulzKompletni = (delka1 < MAX_IMPULSE_SIZE); //TODO - dodelat do .dat souboru
		*vypadek_ns = cas_lost1;
		*vypadek_pulzy = lost_impulses1;

	} while (read);

	return 1;
}

FILE *fileSelectedImpulses = NULL;
char fileSelectedImpulsesName[100];
int numStoredSelectedImpulses = 0;

void CloseSohajFile()
{
	fclose(f1);
	fclose(f2);

	if (fileSelectedImpulses != NULL)
    {
        fclose(fileSelectedImpulses);
        printf("Bylo ulozeno %d vybranych pulzu do souboru %.100s\n", numStoredSelectedImpulses, fileSelectedImpulsesName);
    }
}


int PrepareStoringSelectedImpulses(char* fileName, long long borders)
{
	sprintf(fileSelectedImpulsesName, "%.50s%.50s", fileName, "_selectedImpulses.dat");

 	fileSelectedImpulses = fopen(fileSelectedImpulsesName, "wb");
	if (fileSelectedImpulses == NULL)
	{
		fprintf(stderr, "\nCan't open file %.100s for selected impulses!\n", fileSelectedImpulsesName);
		return(0);
	}

	fprintf(fileSelectedImpulses,"#selected impulses\n\n");
	fprintf(fileSelectedImpulses,"#borders_<minE><maxE><minDiscr><maxDiscr> %lld\n", borders);
    fprintf(fileSelectedImpulses,"#period_[ns]     10000\n\n\n");

    numStoredSelectedImpulses = 0;

	return 1;
}


void StoreSelectedImpulse(long long border, float* impulse, int lenght, float amplitude, float discrParam)
{
    int minEnergy = (int)((border / 1000000000000ll) % 10000ll);
    int maxEnergy = (int)((border / 100000000ll) % 10000ll);
    int minDiscrParam = (int)((border / 10000ll) % 10000ll);
    int maxDiscrParam = (int)((border / 1ll) % 10000ll);

    if (amplitude >= minEnergy && amplitude <= maxEnergy && discrParam >= minDiscrParam && discrParam <= maxDiscrParam)
    {
        fprintf(fileSelectedImpulses, "#time_[ns] %d\n", numStoredSelectedImpulses);
        for (int i = 0; i < lenght; i++)
        {
            int n = impulse[i] + 512;
            n = (n < 0) ? 0 : ((n > 0xFFF) ? 0xFFF : n);
            fprintf(fileSelectedImpulses, "%x\n", n);
        }
        fprintf(fileSelectedImpulses, "\n");

        numStoredSelectedImpulses++;
    }
}
