/*********************************************************
* function.h - function for measuring
*
* v_0.1
*
* Copyright (c)2014 Matej Z. All rights reserved.
* matej.zdenek@gmail.com
*********************************************************/

#ifndef __PARAMS_S
#define __PARAMS_S

#include <stdio.h>

typedef struct
{
	int ZPUSOB_NACITANI_DAT_VSTUPNI_UDP_PORT;
	char* SOUBOR1;      //nazev souboru HIGH
	char* SOUBOR2;		//nazev souboru LOW
	char* SOUBOR_OUT;	//nazev vystupniho souboru
	int ODESILAT_DATA_VYSTUPNI_UDP_PORT;
	char* OUTPUT_IP;
	int STATS_INTERVAL_MS;	//perioda vypisovani prubezne statistiky
	char ZPRACOVAVANE_SOUBORY;	//L - jen LOW, H - jen HIGH, B - oba, dojde ke slouceni
	int METODA;
	int POCET_IMPULSU;	//pocet impulzu k nacteni (0 - neomezene nacitani)
	float KONSTANTA_NASOBENI;
	int SUPERPOSITION_THRESHOLD_BOD_ENERGIE_0;		//bod na primce, ktera urcuje threshold pro oddeleni superpozic (bod s energii 0)
	int SUPERPOSITION_THRESHOLD_BOD_ENERGIE_MAX;	//bod na primce, ktera urcuje threshold pro oddeleni superpozic (bod s maximalni energii kterou zvladame)
	long long HRANICE_UKLADANI_PULZU;      //rozsah diskrimminacniho parametru a energie pro vyber pulzu, ktere ulozit na disk
	int PARAM_X;		//univerzln parametr
	int PARAM_Y;		//univerzln parametr
	int PARAM_Z;		//univerzln parametr
} ParamsStruct;


int ParseCommandLineParams(int argc, char **argv, ParamsStruct *params);
void SetDefaultParamsValue(ParamsStruct *params);
void PrintValues(ParamsStruct *params, int vypisHelpu, FILE* file);

#endif //__PARAMS_S
