#ifndef SUPERPOSITIONS_H
#define SUPERPOSITIONS_H

#include "constants.h" // we need MAX_IMPULSE_SIZE

typedef unsigned int uint;

#define MAX_FILTER_SIZE 32

typedef struct {
    float filtered_buffer[MAX_IMPULSE_SIZE];        // buffer for filtered signal
    float diff_buffer[MAX_IMPULSE_SIZE];            // buffer for derivated signal

    float filter_kernel[MAX_FILTER_SIZE];           // buffer for filter kernel
    uint filter_size;

    float pulse_start_threshold;                    // threshold (trigger) for start of the pulse

} superposition_t;


int tom_superposition_init();
int DetekujSuperpozice(float* impuls, int delka, int thresholdBodEnergie0, int thresholdBodEnergieMax, float amplitudaPulzu, float discrParametr, int *parametrSuperpozice);


#endif // SUPERPOSITIONS_H
